# This file was auto-generated by Fern from our API Definition.

import typing

import httpx
import typing_extensions

from .core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .environment import FlatfileEnvironment
from .resources.agents.client import AgentsClient, AsyncAgentsClient
from .resources.auth.client import AsyncAuthClient, AuthClient
from .resources.cells.client import AsyncCellsClient, CellsClient
from .resources.documents.client import AsyncDocumentsClient, DocumentsClient
from .resources.environments.client import AsyncEnvironmentsClient, EnvironmentsClient
from .resources.events.client import AsyncEventsClient, EventsClient
from .resources.files.client import AsyncFilesClient, FilesClient
from .resources.guests.client import AsyncGuestsClient, GuestsClient
from .resources.jobs.client import AsyncJobsClient, JobsClient
from .resources.records.client import AsyncRecordsClient, RecordsClient
from .resources.secrets.client import AsyncSecretsClient, SecretsClient
from .resources.sheets.client import AsyncSheetsClient, SheetsClient
from .resources.spaces.client import AsyncSpacesClient, SpacesClient
from .resources.users.client import AsyncUsersClient, UsersClient
from .resources.versions.client import AsyncVersionsClient, VersionsClient
from .resources.workbooks.client import AsyncWorkbooksClient, WorkbooksClient


class Flatfile:
    def __init__(
        self,
        *,
        environment: FlatfileEnvironment = FlatfileEnvironment.PRODUCTION,
        x_disable_hooks: typing_extensions.Literal["true"],
        token: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._environment = environment
        self._client_wrapper = SyncClientWrapper(
            x_disable_hooks=x_disable_hooks, token=token, httpx_client=httpx.Client(timeout=timeout)
        )
        self.spaces = SpacesClient(environment=environment, client_wrapper=self._client_wrapper)
        self.agents = AgentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.auth = AuthClient(environment=environment, client_wrapper=self._client_wrapper)
        self.cells = CellsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.documents = DocumentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.environments = EnvironmentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.events = EventsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.files = FilesClient(environment=environment, client_wrapper=self._client_wrapper)
        self.guests = GuestsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.jobs = JobsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.records = RecordsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.secrets = SecretsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.sheets = SheetsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.users = UsersClient(environment=environment, client_wrapper=self._client_wrapper)
        self.versions = VersionsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.workbooks = WorkbooksClient(environment=environment, client_wrapper=self._client_wrapper)


class AsyncFlatfile:
    def __init__(
        self,
        *,
        environment: FlatfileEnvironment = FlatfileEnvironment.PRODUCTION,
        x_disable_hooks: typing_extensions.Literal["true"],
        token: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._environment = environment
        self._client_wrapper = AsyncClientWrapper(
            x_disable_hooks=x_disable_hooks, token=token, httpx_client=httpx.AsyncClient(timeout=timeout)
        )
        self.spaces = AsyncSpacesClient(environment=environment, client_wrapper=self._client_wrapper)
        self.agents = AsyncAgentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.auth = AsyncAuthClient(environment=environment, client_wrapper=self._client_wrapper)
        self.cells = AsyncCellsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.documents = AsyncDocumentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.environments = AsyncEnvironmentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.events = AsyncEventsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.files = AsyncFilesClient(environment=environment, client_wrapper=self._client_wrapper)
        self.guests = AsyncGuestsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.jobs = AsyncJobsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.records = AsyncRecordsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.secrets = AsyncSecretsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.sheets = AsyncSheetsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.users = AsyncUsersClient(environment=environment, client_wrapper=self._client_wrapper)
        self.versions = AsyncVersionsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.workbooks = AsyncWorkbooksClient(environment=environment, client_wrapper=self._client_wrapper)
