# This file was auto-generated by Fern from our API Definition.

import typing

import httpx
import typing_extensions


class BaseClientWrapper:
    def __init__(
        self, *, x_disable_hooks: typing_extensions.Literal["true"], token: typing.Union[str, typing.Callable[[], str]]
    ):
        self._x_disable_hooks = x_disable_hooks
        self._token = token

    def get_headers(self) -> typing.Dict[str, str]:
        headers: typing.Dict[str, str] = {}
        headers["X-Disable-Hooks"] = self._x_disable_hooks
        headers["Authorization"] = f"Bearer {self._get_token()}"
        return headers

    def _get_token(self) -> str:
        if isinstance(self._token, str):
            return self._token
        else:
            return self._token()


class SyncClientWrapper(BaseClientWrapper):
    def __init__(
        self,
        *,
        x_disable_hooks: typing_extensions.Literal["true"],
        token: typing.Union[str, typing.Callable[[], str]],
        httpx_client: httpx.Client,
    ):
        super().__init__(x_disable_hooks=x_disable_hooks, token=token)
        self.httpx_client = httpx_client


class AsyncClientWrapper(BaseClientWrapper):
    def __init__(
        self,
        *,
        x_disable_hooks: typing_extensions.Literal["true"],
        token: typing.Union[str, typing.Callable[[], str]],
        httpx_client: httpx.AsyncClient,
    ):
        super().__init__(x_disable_hooks=x_disable_hooks, token=token)
        self.httpx_client = httpx_client
