# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ....core.datetime_utils import serialize_datetime
from ...commons.types.guest_id import GuestId
from ...commons.types.space_id import SpaceId


class Invite(pydantic.BaseModel):
    guest_id: GuestId = pydantic.Field(alias="guestId")
    space_id: SpaceId = pydantic.Field(alias="spaceId")
    from_name: typing.Optional[str] = pydantic.Field(
        alias="fromName", description="The name of the person or company sending the invitation"
    )
    message: typing.Optional[str] = pydantic.Field(description="Message to send with the invite")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
