# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ....core.datetime_utils import serialize_datetime
from ...commons.types.success_data import SuccessData
from ...commons.types.version_id import VersionId
from .record_counts import RecordCounts
from .records_with_links import RecordsWithLinks


class RecordsResponseData(SuccessData):
    """
    A list of records with optional record counts
    """

    records: typing.Optional[RecordsWithLinks]
    counts: typing.Optional[RecordCounts]
    version_id: typing.Optional[VersionId] = pydantic.Field(alias="versionId")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
